package com.ruoyi.project.listener.pssr;

import com.alibaba.fastjson.JSON;
import com.github.stuxuhai.jpinyin.PinyinFormat;
import com.github.stuxuhai.jpinyin.PinyinHelper;
import com.ruoyi.common.jpush.JiGuangPushService;
import com.ruoyi.common.sendEmail.IMailService;
import com.ruoyi.common.utils.SpringContextUtils;
import com.ruoyi.project.invoice.domain.TApproveReserveInvoice;
import com.ruoyi.project.invoice.domain.TInvoiceBookingworkticket;
import com.ruoyi.project.invoice.service.ITApproveReserveInvoiceService;
import com.ruoyi.project.invoice.service.ITInvoiceBookingworkticketService;
import com.ruoyi.project.pssr.domain.TPssrApprove;
import com.ruoyi.project.pssr.service.ITPssrApproveService;
import com.ruoyi.project.system.domain.SysMessage;
import com.ruoyi.project.system.domain.SysUser;
import com.ruoyi.project.system.service.ISysMessageService;
import com.ruoyi.project.system.service.ISysUserService;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.TaskListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Date;

@Service("confirmTaskCreateListener")
public class ConfirmTaskCreateListener implements Serializable, TaskListener {
    protected Logger logger = LoggerFactory.getLogger(getClass());

    @Override
    public void notify(DelegateTask delegateTask) {
        String id = delegateTask.getExecution().getProcessInstanceBusinessKey();
        ITPssrApproveService approveService = (ITPssrApproveService) SpringContextUtils.getBean("tPssrApproveService");
        ISysMessageService sysMessageService = (ISysMessageService) SpringContextUtils.getBean("sysMessageService");
        ISysUserService sysUserService = (ISysUserService) SpringContextUtils.getBean("sysUserService");
        JiGuangPushService jiGuangPushService = (JiGuangPushService) SpringContextUtils.getBean("jiGuangPushService");
        IMailService mailService = (IMailService) SpringContextUtils.getBean("mailService");
        TPssrApprove approveEntity = approveService.selectTPssrApproveById(Long.parseLong(id));
        String assignee = delegateTask.getAssignee();

        logger.info("==============================发邮件============================");
        //发送邮件
        try {
            String email = sysUserService.selectUserById(Long.parseLong(assignee)).getEmail();
            String apNo = approveEntity.getApNo();
            logger.info("apNo:" + apNo);
            SysUser sysUser = sysUserService.selectUserById(Long.parseLong(assignee));
            String username = sysUser.getNickName();
            String loginName = sysUser.getUserName();
            String usernameEN = PinyinHelper.convertToPinyinString(username, " ", PinyinFormat.WITHOUT_TONE);
            logger.info("email:" + email);
            logger.info("username:" + username);
            //写html开始内容
            String start = "<!DOCTYPE html><html><head><meta charset=\"utf-8\"><title></title></head><body><div style=\"background-color:#ECECEC; padding: 35px;\">" +
                    "<table cellpadding=\"0\" align=\"center\"" +
                    "style=\"width: 600px; margin: 0px auto; text-align: left; position: relative; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; font-size: 14px; font-family:微软雅黑, 黑体; line-height: 1.5; box-shadow: rgb(153, 153, 153) 0px 0px 5px; border-collapse: collapse; background-position: initial initial; background-repeat: initial initial;background:#fff;\">" +
                    "<tbody><tr><th valign=\"middle\" style=\"height: 25px; line-height: 25px; padding: 15px 35px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: #42a3d3; background-color: #49bcff; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px;\">" +
                    "<font face=\"微软雅黑\" size=\"5\" style=\"color: rgb(255, 255, 255); \">PSSR检查确认 </font><font face=\"微软雅黑\" size=\"3\" style=\"color: rgb(255, 255, 255); \">PSSR</font></th></tr>";
            //表html中间内容
            String prime = "";
            String center = "<tr><td><div style=\"padding:25px 35px 40px; background-color:#fff;\"><h2 style=\"margin: 5px 0px; \">" +
                    "<font color=\"#333333\" style=\"line-height: 20px; \"><font style=\"line-height: 22px; \" size=\"4\">" +
                    "亲爱的 username(loginName)</font><br><font style=\"line-height: 22px; \" size=\"4\">" +
                    "Dear usernameEN(loginName)</font></font></h2>" +
                    "<p>您有一个PSSR的待办任务：<br>" +
                    "You have a pending PSSR task:<br>" +
                    "请登录<a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">PSSR待办中</a>查看。<br>" +
                    "Please log in the <a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">PSSRApprove</a> to handle it.</p>" +
                    "<p align=\"right\">date</p>" +
                    "<div style=\"width:700px;margin:0 auto;\">" +
                    "<div style=\"padding:10px 10px 0;border-top:1px solid #ccc;color:#747474;margin-bottom:20px;line-height:1.3em;font-size:12px;\">" +
                    "<p>此为系统邮件，请勿回复<br>This e-Mail is an automatic reminder sent by CPMS, please do not reply</p>" +
                    "</div></div></div></td></tr>";
            String one = center.replaceFirst("username", username);
            String two = one.replaceFirst("usernameEN", usernameEN);
            String three = two.replace("loginName", loginName);
            String four = three.replaceFirst("apNo", apNo);
            String five = four.replaceFirst("apNoEN", apNo);
            String result = five.replaceFirst("date", String.valueOf(new Date()));
            prime = prime + result;
            //写html结尾内容
            String end = "</tbody></table></div></body></html>";
            //拼接html
            String html = start + prime + end;
            logger.info("html:" + html);
            mailService.sendHtmlMail(email, "PSSR：您有一个新的待办任务 PSSR:You have a pending PSSR task (" + apNo + ")", html);

        } catch (Exception e) {
            logger.error("邮件发送失败" + JSON.toJSONString(e));
        }
        try {
            //极光推送
            jiGuangPushService.send("PSSR审批", "您有一个新的待办任务，请及时处理。", assignee);

            //系统消息推送
            SysMessage sysMessage = new SysMessage();
            sysMessage.setMsgTitle("PSSR审批");
            sysMessage.setMsgContent("您有一个新的待办任务，请及时处理。");
            sysMessage.setUserId(Long.parseLong(assignee));
            sysMessageService.insertSysMessage(sysMessage);
        } catch (Exception e) {
            logger.error("推送失败：{}" , JSON.toJSONString(e));
        }

    }
}
